package com.iformall.controller;

import com.github.pagehelper.PageInfo;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.domain.po.WxBusiness;
import com.iformall.service.WxBusinessService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.stream.Collectors;

@RestController
@RequestMapping("wxBusiness")
@Api(description = "业态接口")
public class WxBusinessController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxBusinessService wxBusinessService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    public ResultData list(@ModelAttribute WxBusiness wxBusiness, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxBusinessController::list");
        if (null == wxBusiness) wxBusiness = new WxBusiness();
        final PageInfo<WxBusiness> page = wxBusinessService.listAsPage(wxBusiness, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("成长值业态列表接口")
    @GetMapping("busListForScore")
    public ResultData getList() {
        logger.debug("[" + getIpAddr() + "] WxBusinessController::getList");
        WxBusiness wxBusiness = new WxBusiness();
        final List<WxBusiness> busList = wxBusinessService.getList(wxBusiness);
        // 业态 全部 不返回
        List<WxBusiness> busList2 = busList.stream().filter(b -> !b.getId().equals(0L)).collect(Collectors.toList());
        return new ResultData(busList2);
    }

    @ApiOperation("业态全列表接口")
    @GetMapping("allist")
    public ResultData getAllList() {
        logger.debug("[" + getIpAddr() + "] WxBusinessController::getList");
        WxBusiness wxBusiness = new WxBusiness();
        final List<WxBusiness> busList = wxBusinessService.getList(wxBusiness);
        return new ResultData(busList);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    public ResultData add(@RequestBody WxBusiness wxBusiness) {
        logger.debug("[" + getIpAddr() + "] WxBusinessController::add");
        //Assert.notNull(wxBusiness.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    public ResultData update(@RequestBody WxBusiness wxBusiness) {
        logger.debug("[" + getIpAddr() + "] WxBusinessController::update");
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxBusinessController::delete");
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    public ResultData findById(Integer id) {
        logger.debug("[" + getIpAddr() + "] WxBusinessController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxBusinessService.getById(id));
    }


}
